import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class itWorks extends PApplet {

Shape[] shapes;

public void setup () {
  size (1366, 768);
  smooth();

  shapes = new Shape [20];
  for (int x=0; x<shapes.length;x++)
  {
    shapes[x] = new Shape((float)random(50,550),(float) random(50,450));
  }
}

public void draw() {
  frameRate(120);
  background(0);
  for (int a=0; a<shapes.length; a++) {
    shapes[a].display();
    shapes[a].drift();
    shapes[a].checkCollision();
    for (int j=a;j<shapes.length;j++) 
    {
      if ((shapes[a]!=shapes[j]))
      {
        PVector P = PVector.sub(shapes[j].pos, shapes[a].pos);
        float d=P.mag();
        if (d <= shapes[j].mass + shapes[a].mass)
        {
          P.normalize();
          d -= shapes[j].mass + shapes[a].mass;
          float n=shapes[a].speed.mag()+shapes[j].speed.mag();
          shapes[a].pos.add(PVector.mult(P, d*shapes[a].speed.mag()/(n)));
          shapes[j].pos.add(PVector.mult(P, -1*d*shapes[j].speed.mag()/(n))); 
          PVector N = new PVector(P.y, P.x*(-1), 0); 
          float vp1 = shapes[a].speed.dot(P); 
          float vn1 = shapes[a].speed.dot(N); 
          float vp2 = shapes[j].speed.dot(P);  
          float vn2 = shapes[j].speed.dot(N);   
          // calculate collison
          float vp1_after=0;
          float vp2_after=0;
          vp1_after = (shapes[a].mass*vp1+shapes[j].mass*(2*vp2-vp1))/(shapes[a].mass+shapes[j].mass);
          vp2_after = (shapes[a].mass*(2*vp1-vp2)+shapes[j].mass*vp2)/(shapes[a].mass+shapes[j].mass);
          shapes[a].speed=PVector.add(PVector.mult(P, vp1_after), PVector.mult(N, vn1));
          shapes[j].speed=PVector.add(PVector.mult(P, vp2_after), PVector.mult(N, vn2));
          shapes[a].setColor(color(random(50,255), random(50,255), random(50,255)));
          shapes[j].setColor(color(random(50,255), random(50,255), random(50,255)));
        }
      }
    }
  }
}

class Shape {
    PVector speed;
    PVector pos;
    float mass;
    int full;
    public boolean isOver(float x,float y)
      {
        if (dist(x,y,pos.x,pos.y)<mass) return true;
        return false;
      }
      
  public Shape(float x, float y) {
    speed= new PVector(random(-5,5),random(-0.1f,0.1f));
    pos= new PVector(x,y);
    mass = random(10,80);
    full = color(random(50,255), random(50,255), random(50,255));
  }
  public void display() {  // Draw Sphere
    stroke(0);
    fill(full, 255);
    ellipse(pos.x, pos.y, mass*2, mass*2);
  }
  public void drift() {
    pos.add(speed);
  }
  public void setColor(int ehh)
  {
    full=ehh;
  }
  public void checkCollision() {
    if (pos.x-mass<=0||pos.x+mass>=width) {
      speed.x=(speed.x*(-1));//setDirection(-getDirection()+(float)Math.PI);
      if(pos.x-mass <= 0) pos.x = mass;
      if(pos.x+mass >= width) pos.x = width-mass;
    }
    if (pos.y-mass<=0||pos.y+mass>=height) {
      speed.y=(speed.y*(-1));//setDirection(-getDirection()+(2*(float)Math.PI));
      if(pos.y-mass <= 0) pos.y = mass;
      if(pos.y+mass >= height) pos.y = height-mass;
    }
  }
}

  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "--full-screen", "--bgcolor=#666666", "--stop-color=#cccccc", "itWorks" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
