Shape[] shapes;

void setup () {
  size (1366, 768);
  smooth();

  shapes = new Shape [20];
  for (int x=0; x<shapes.length;x++)
  {
    shapes[x] = new Shape((float)random(50,550),(float) random(50,450));
  }
}

void draw() {
  frameRate(120);
  background(0);
  for (int a=0; a<shapes.length; a++) {
    shapes[a].display();
    shapes[a].drift();
    shapes[a].checkCollision();
    for (int j=a;j<shapes.length;j++) 
    {
      if ((shapes[a]!=shapes[j]))
      {
        PVector P = PVector.sub(shapes[j].pos, shapes[a].pos);
        float d=P.mag();
        if (d <= shapes[j].mass + shapes[a].mass)
        {
          P.normalize();
          d -= shapes[j].mass + shapes[a].mass;
          float n=shapes[a].speed.mag()+shapes[j].speed.mag();
          shapes[a].pos.add(PVector.mult(P, d*shapes[a].speed.mag()/(n)));
          shapes[j].pos.add(PVector.mult(P, -1*d*shapes[j].speed.mag()/(n))); 
          PVector N = new PVector(P.y, P.x*(-1), 0); 
          float vp1 = shapes[a].speed.dot(P); 
          float vn1 = shapes[a].speed.dot(N); 
          float vp2 = shapes[j].speed.dot(P);  
          float vn2 = shapes[j].speed.dot(N);   
          // calculate collison
          float vp1_after=0;
          float vp2_after=0;
          vp1_after = (shapes[a].mass*vp1+shapes[j].mass*(2*vp2-vp1))/(shapes[a].mass+shapes[j].mass);
          vp2_after = (shapes[a].mass*(2*vp1-vp2)+shapes[j].mass*vp2)/(shapes[a].mass+shapes[j].mass);
          shapes[a].speed=PVector.add(PVector.mult(P, vp1_after), PVector.mult(N, vn1));
          shapes[j].speed=PVector.add(PVector.mult(P, vp2_after), PVector.mult(N, vn2));
          shapes[a].setColor(color(random(50,255), random(50,255), random(50,255)));
          shapes[j].setColor(color(random(50,255), random(50,255), random(50,255)));
        }
      }
    }
  }
}

